#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
#include <curl/curl.h>
using namespace std;


struct Input
{
    vector<double> numbers;
    size_t bin_count{};
    size_t number_count{};
    size_t max_count{};
};

Input
input_data(istream& stream, bool prompt)
{
    size_t number_count;
    if (prompt)
    {
        cerr << "Enter number count: ";
    }
    stream >> number_count;
    Input in;
    if (prompt)
    {
        cerr << "Enter bin count: ";
    }
    stream >> in.bin_count;
    vector<double> numbers(in.number_count);
    in.numbers.resize(in.number_count);
    for (size_t i = 0; i < in.number_count; i++)
    {
        stream >> in.numbers[i];
    }
    size_t bin_count;
    size_t max_count;
    in.max_count = 0;
    return in;
}



int main(int argc, char* argv[])
{

    if (argc > 1)
    {
        CURL* curl = curl_easy_init();
        if(curl)
        {
            CURLcode res;
            curl_easy_setopt(curl, CURLOPT_URL, argv[1]);
            res = curl_easy_perform(curl);
            if (res != CURLE_OK)
            {
                curl_easy_strerror(res);
                exit(1);
            }
            curl_easy_cleanup(curl);
        }
        return 0;
    }
    curl_global_init(CURL_GLOBAL_ALL);
    bool prompt = true;
    auto in = input_data(cin, prompt);
    auto bins = make_histogram(in.numbers, in.bin_count, in.number_count, in.max_count);
    vector<double> test;
    show_histogram_svg(bins, in.max_count, in.bin_count, test);
    return 0;
}
